#define GLX_SYM_NO_DEFINES
#include "glx_symbols.h"

#define FAKESNUM 0	/* fake knowing our screen number. clean up later*/


#include <dlfcn.h>
#include <stdio.h>
#include <unistd.h>

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifdef HAVE_SYS_MMAN_H
#include <sys/mman.h>
#endif

#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

int __glx_is_server = 1;
int __glx_first_visual = 0;	/* big hack */

GlxDriverSyms glxsym;

/* This section used to have our own version of
 * xf86LinearVidMem(), xf86MapVidMem(), xf86UnMapVidMem()
 * But now all that is part of xfree4
 */
#include "os-support/xf86_OSproc.h"


int glxInstallLocalSVGASymbols( void )
{

#if !defined(__SOL8__)
   /* Not sure this actually works any more. remember, this is for
    * 'direct' rendering, which means we are in a wierd symbol state.
    * Direct rendering isnt being tested currently.
    */
   glxsym.xf86VTSema = &(xf86Screens[FAKESNUM]->vtSema);
   GLXSYM(xf86VTSema) = 1;
#endif

   /*   glxsym.xf86MapVidMem = &xf86MapVidMem;
   glxsym.xf86UnMapVidMem = &xf86UnMapVidMem;
   */
   glxsym.pciReadLong = 0;
   glxsym.pciWriteLong = 0;

   return glxHookX11ClientSymbols();
}


int glxInstallLocalMach64Symbols( void )
{
   glxsym.xf86VTSema = 0;

/*I   glxsym.xf86MapVidMem = &xf86MapVidMem;
   glxsym.xf86UnMapVidMem = &xf86UnMapVidMem;
*/
   glxsym.pciReadLong = 0;
   glxsym.pciWriteLong = 0;


   return glxHookX11ClientSymbols();
}



static int any_error;
static void *my_dlsym(void *handle, const char *name)
{
   void *tmp = dlsym(handle, name);
   char *error;
   if ((error = dlerror()) != 0) {
      fprintf( stderr, "%s\n", error );
      any_error = 1;
      return 0;
   }
   return tmp;
}

/* Some of these symbols are also loaded by the mach64 driver 
 * when running against the XF86_mach64 server.
 */
int glxHookSVGAServerSymbols( void *handle )
{
   /* NOTE: Any XAA acceleration stuff is card-specific. Therefore,
    * it will be done in the hardware-specific subsections, if at all
    */
    any_error = 0;
    /*XXX hardcode bad */
    /* Should really recode the whole GLXSYM thing to be
     * on a per-screen basis. Or something like that.
     */
    
   {/* Ugly now, to make it nicer later */
	ScrnInfoPtr **scrnlistptr;
	scrnlistptr=my_dlsym(handle,"xf86Screens");
	glxsym.scrninfoList= *scrnlistptr;
	/* glxsym.scrninfoList[0] is now a ScrnInfoRec for screen 0 */
   }
#if !defined(__SOL8__)
   glxsym.xf86VTSema = &(glxsym.scrninfoList[FAKESNUM]->vtSema);
#endif

   fprintf(stderr, "DEBUG: fbOffset for screen0 is %lx\n",
	   glxsym.scrninfoList[0]->fbOffset);

   glxsym.xf86MapVidMem = my_dlsym(handle, "xf86MapVidMem");
   glxsym.xf86UnMapVidMem = my_dlsym(handle, "xf86UnMapVidMem");
   glxsym.pciReadLong = my_dlsym(handle, "pciReadLong");
   glxsym.pciWriteLong = my_dlsym(handle, "pciWriteLong");

   if (!any_error) 
      fprintf(stderr, "Sucessfully loaded XF86_SVGA server symbols\n");
   else
      fprintf(stderr, "XF86_SVGA server not detected (missing symbols)\n");

   return !any_error;
}


int glxHookMach64ServerSymbols( void *handle )
{
    any_error = 0;
#ifdef XFREE3
   glxsym.mach64InfoRec = my_dlsym(handle, "mach64InfoRec");
   glxsym.mach64MemRegMap = my_dlsym(handle, "mach64MemRegMap");
   glxsym.mach64VideoMem = my_dlsym(handle, "mach64VideoMem");
   glxsym.mach64ApertureAddr = my_dlsym(handle, "mach64ApertureAddr");
   glxsym.mach64ApertureSize = my_dlsym(handle, "mach64ApertureSize");
   glxsym.pciReadLong = my_dlsym(handle, "pciReadLong");
   glxsym.pciWriteLong = my_dlsym(handle, "pciWriteLong");
   glxsym.xf86MapVidMem = my_dlsym(handle, "xf86MapVidMem");
   glxsym.xf86UnMapVidMem = my_dlsym(handle, "xf86UnMapVidMem");

   if (!any_error)
      fprintf(stderr, "Sucessfully initialized Mach64 server symbols\n");
   else
      fprintf(stderr, "XF86_Mach64 server not detected (missing symbols)\n");

   return !any_error;
#else
   return(atiHookServerSymbols(handle));
#endif

}


/* This one is a bit funny as I don't see any definitions in the
 * header files for some of these constants:
* This seems to be a MACH64 Specific hook routine for the fb_Dev XF3 Server
* I'm not sure if this server still exists, but anyway, it doesn't really seem to be needed
* For now just remove the key interfering code with a #ifdef XFREE3

 */
int glxHookFbDevServerSymbols( void *handle )
{
    any_error = 0;
#ifdef XFREE3
   glxsym.fbdevInfoRec = my_dlsym(handle, "fbdevInfoRec");
   glxsym.fbdevVirtBase = my_dlsym(handle, "fbdevVirtBase");
   glxsym.fbdevRegBase = my_dlsym(handle, "fbdevRegBase");
#else
   any_error=1;
#endif
   if (!any_error)
      fprintf(stderr,
	      "Successfully inited Mach64 driver symbols for XF86_FbDev\n");
   else
#ifdef XFREE3
      fprintf(stderr, "XF86_FbDev server not detected (missing symbols)\n");
#else
      fprintf(stderr, "XF86_FbDev server not Supported\n");
#endif

   return !any_error;
}


/* Hook in symbols common to all the XFree86 3.3 Servers.
 * But now slight adjusted to look for symbols in the xfree4.x server
 */
int glxHookXFree86Symbols( void *handle )
{
   fprintf(stderr,"DEBUG: in glxHookXFree86Symbols\n");

   glxsym.AddExtension = my_dlsym(handle, "AddExtension");
   glxsym.StandardMinorOpcode = my_dlsym(handle, "StandardMinorOpcode");
   glxsym.AddResource = my_dlsym(handle, "AddResource");
   glxsym.CreateNewResourceType = my_dlsym(handle, "CreateNewResourceType");
   glxsym.FreeResource = my_dlsym(handle, "FreeResource");
   glxsym.LookupIDByClass = my_dlsym(handle, "LookupIDByClass");
   glxsym.LookupIDByType = my_dlsym(handle, "LookupIDByType");
   glxsym.SecurityLookupIDByClass = my_dlsym(handle, "SecurityLookupIDByClass");
   glxsym.SecurityLookupIDByType = my_dlsym(handle, "SecurityLookupIDByType");
   glxsym.AllocColor = my_dlsym(handle, "AllocColor");
   glxsym.QueryColors = my_dlsym(handle, "QueryColors");
   glxsym.ErrorF = my_dlsym(handle, "ErrorF");
   glxsym.FatalError = my_dlsym(handle, "FatalError");
   glxsym.FlushAllOutput = my_dlsym(handle, "FlushAllOutput");
   glxsym.FreeScratchGC = my_dlsym(handle, "FreeScratchGC");
   glxsym.GetScratchGC = my_dlsym(handle, "GetScratchGC");
   glxsym.DoChangeGC = my_dlsym(handle, "DoChangeGC");
   glxsym.ValidateGC = my_dlsym(handle, "ValidateGC");

/*   glxsym.GlxExtensionInitPtr = my_dlsym(handle, "GlxExtensionInitPtr");
   glxsym.GlxInitVisualsPtr = my_dlsym(handle, "GlxInitVisualsPtr");
*/

   glxsym.FakeClientID = my_dlsym(handle, "FakeClientID");
   glxsym.FindWindowWithOptional = my_dlsym(handle, "FindWindowWithOptional");
   glxsym.LocalClient = my_dlsym(handle, "LocalClient");
   glxsym.WriteToClient = my_dlsym(handle, "WriteToClient");
   glxsym.Xalloc = my_dlsym(handle, "Xalloc");
   glxsym.Xfree = my_dlsym(handle, "Xfree");
   glxsym.PixmapWidthPaddingInfo = my_dlsym(handle, "PixmapWidthPaddingInfo");
   glxsym.screenInfo = my_dlsym(handle, "screenInfo");
   fprintf(stderr,"debug: dlsym says screenInfo is %p, Loadersym says %p\n",
	   glxsym.screenInfo,LoaderSymbol("screenInfo"));

   if (!any_error) 
      fprintf(stderr, "Sucessfully loaded XFree86 3.3 symbols\n");
   else
      fprintf(stderr, "XFree86 3.3 server not detected (missing symbols)\n");

   return !any_error;
}
