#ifndef _ATI_SYMBOLS_H
#define _ATI_SYMBOLS_H


//Fixme, must define in a configure test

#define XF41  // Hack to get IOADDRESS type right which changes from XF4.1 to XF4.2 Beware



#include "xf86xv.h" /* includes xf86str.h, among other things */
#include "xf86Pci.h"
#ifdef XF41 
typedef CARD16 IOADDRESS;
#endif
#include "atistruct.h" /* xfree4 ati driver private data structures driver include
					Defines ATIRec and ATIHWRec */


// Gotta get these two things from somewhere
#define ATIGLX_NUMTEXTUREBLOCKS 2  // Stub, might break things -- FixMe
#define ATI_TEX_BLOCK_SIZE 128 // Stub, dunno about this --- FIxMe


/* Information that is specific to a particular card.
 * This is made this way in the hopes that one day, we will be able
 * to support hardware accel on more than one card.
 * Some of this stuff is merely copied over from the core xfree nv
 * driver info structs. Other parts are calculated.
 * We have this info here becuase hopefully it will result in less
 * dereferencing. PLUS, it lets us set up the info once in nvInitGLX(),
 * then use a consistant interface to it for all other routines.
 */
/*
From glx_symbols.h, these are the ATI specific things we want to move to a per screen
Structure in the driver

 ScrnInfoRec	*mach64InfoRec;
   pointer	*mach64MemRegMap;
   pointer	*mach64VideoMem;
   unsigned long	*mach64ApertureAddr;
   unsigned long	*mach64ApertureSize; */
   /* also in fbdev server?  */

   /* mach64 PPC fbdev server info*/
/*   ScrnInfoRec	*fbdevInfoRec;
   int	*fbdevVirtBase;
   int	*fbdevRegBase;
*/



typedef struct ati_glx_info_s {
	ATIPtr xfree_atirec;   /* xfree4 ati driver private data */
	/* Sub-values of interest:
	 * xfree_nvrec->FbAddress == physical MemBase
	 * xfree_nvrec->FbBase    == MMAPPED video memory
	 * xfree_nvrec->IOAddress == [physical addr for "MMIO" ?]
	 * xfree_nvrec->IOBase    == MMAPED IOAddress
	 * xfree_nvrec->FbMapSize == vidram in BYTES
	 * xfree_nvrec->FbUsableSize == subset of FbMapSize:
	 *                              reserves either 32k or 128k mem
	 */
	 ATIHWRec *atihw;   /* shortcut for ATI HWRec Hardware descriptor */
    	ScrnInfoPtr pScrnInfo; /* Pointer to screen info as supplied by Xfor this screen, get geometry from here*/

	CARD32 videoareasize;   /* amount of mem that is actually displayed
	                      * onscreen as the user-visible screen
			      */
	unsigned char *privMemBase; /* mmapped address of our special vidmem*/

	CARD32 privMemOffset; /* offset from "vidram address 0".*/
	int privMemSize;	/* bytes in privMemBase mmap */

	/* This section is replacement for rivaBufferOffset[] numbers */
	CARD32 frontbufferoffset;
	CARD32 backbufferoffset;
	CARD32 depthbufferoffset;
	/* and now obviously the mmaped addresses */
	char *backbufmappedaddr;
	char *depthbufmappedaddr;

	int depth_bits; /* bits per pixel in depthbuffer */

	/* These two are offshoots of original rivaBuffOffset[RIVA_TEXTURE...]
	 * where the original was a single 'base' value, I now precalculate
	 * all the address positions and offsets.
	 * Multiplication is slow compared to pointer dereference.
	 * 'offset' is purely from start of video ram. I think.
	 * texturebase needs to be in same address space (local, or phys?)
	 * as original ones. texturebase[0]=vidMem+textureoffset[0]
	 */
	CARD32 textureoffset[ATIGLX_NUMTEXTUREBLOCKS];
	/* actual address of texture block */
	CARD32 texturebase[ATIGLX_NUMTEXTUREBLOCKS];
				/* Note that according to riva_glx.h,
				 * current size of a texture block is
				 * merely 8192 bytes
				 */
	int numtexblocks;

	int atiRendered2D;	/* rivaReload3D is aliased to this also */

} ATI_GLX_INFO;

extern ATI_GLX_INFO *ati_sinfo; /* per-screen info */

#endif /* _ATI_SYMBOLS_H */
